#!/usr/bin/python3

#----------------------------------------------------------------
# Dateiname:  searchplace.py 
# CGI-Skript zur Suche einer Fundstelle für Früchte.
#
# Michael Weigend: Raspberry Pi programmieren mit Python, mitp 2013
# 11.5.2
# 29.10.2013
#----------------------------------------------------------------
import cgi, cgitb, sqlite3
cgitb.enable()

HTML = {ord('ä'): '&auml;', ord('ö'): '&ouml;',
        ord('ü'): '&uuml;', ord('Ä'): '&Auml;',
        ord('Ö'): '&Ouml;', ord('Ü'): '&Uuml;',
        ord('ß'): '&szlig'}

RESPONSE='''Content-Type: text/html

<html>
<meta http-equiv="Content-Type" content="charset=utf-8" />
  <head>
        <title>Suchergebnisse</title>
  </head>
<body>
  <h2> Wo darf man kostenlos ernten?</h2>
   <p> %s </p>
   <a href="http://192.168.178.42/raspberries/">Startseite</a>
  </body>
</html>'''

form = cgi.FieldStorage()
fruit = form.getvalue('fruit', '').translate(HTML)

try:
    conn=sqlite3.connect('data/fruits.db')
    c = conn.cursor()
    query = '''SELECT place
           FROM location
           WHERE fruit=?'''
    c.execute(query, (fruit,))
    rows = list(c)
    if len(rows) > 0:
        results ='<h3>Hier findest du %s</h3>' % fruit
        for row in rows:
               results += ('<p> %s </p>' % row[0])
        print (RESPONSE % results)
    else:
        print (RESPONSE % ('Leider habe ich keine passenden Fundstellen.'))
except:
    print (RESPONSE % ('Leider sind keine Daten vorhanden.'))
           
